export class Session {
    constructor(e) {
        this.session = e.session;
        this.callId = e.request.getHeader('X-Webitel-Uuid');
        this.incoming = e.session.direction === 'incoming';
        this.instanceId = e.request.getHeader('X-Webitel-Sock-Id');
    }
    get id() {
        return this.session.id;
    }
    getLocalMedia() {
        if (this.session.connection) {
            const local = this.session.connection.getLocalStreams();
            if (local.length) {
                return local;
            }
        }
        return [];
    }
    getPeerMedia() {
        if (this.session.connection) {
            const peer = this.session.connection.getRemoteStreams();
            if (peer.length) {
                return peer;
            }
        }
        return [];
    }
    answer(s) {
        return new Promise(() => {
            this.session.answer(s);
        });
    }
}
//# sourceMappingURL=session.js.map