import { EventEmitter } from 'ee-ts';
import { formatWebSocketUri } from './utils';
const SOCKET_URL_SUFFIX = 'websocket';
const spamData = `\u0000\u0000\u0000\u0000`;
export class Socket extends EventEmitter {
    constructor(host) {
        super();
        this.host = host;
        // this.socket = null
    }
    connect(token) {
        this.socket = new WebSocket(`${formatWebSocketUri(this.host)}/${SOCKET_URL_SUFFIX}`);
        this.socket.onclose = (e) => this.onClose(e.code);
        this.socket.onmessage = (e) => this.onMessage(e.data);
        this.socket.onopen = () => this.onOpen();
    }
    send(request) {
        this.socket.send(JSON.stringify(request));
        return null;
    }
    close(code) {
        this.socket.close(code || 1000);
        delete this.socket;
    }
    onOpen() {
        this.emit('open');
    }
    onClose(code) {
        this.emit('close', code);
        this.off('*');
    }
    onMessage(data) {
        if (data !== spamData) {
            const message = JSON.parse(data);
            this.emit('message', message);
        }
    }
}
//# sourceMappingURL=socket.js.map