import { __awaiter, __extends, __generator } from "tslib";
import BaseDeleterApiConsumer from '../base-deleter-api-consumer/base-deleter-api-consumer';
var EndpointDeleterApiConsumer = /** @class */ (function (_super) {
    __extends(EndpointDeleterApiConsumer, _super);
    function EndpointDeleterApiConsumer(_a, params) {
        var baseUrl = _a.baseUrl, instance = _a.instance;
        if (params === void 0) { params = {}; }
        var _this = _super.call(this) || this;
        _this.instance = instance;
        _this.baseUrl = baseUrl;
        if (params.nestedUrl)
            _this.nestedUrl = params.nestedUrl;
        return _this;
    }
    EndpointDeleterApiConsumer.prototype.deleteItem = function (_a) {
        var id = _a.id;
        return this._deleteItem({ id: id });
    };
    EndpointDeleterApiConsumer.prototype.deleteNestedItem = function (_a) {
        var parentId = _a.parentId, id = _a.id;
        var baseUrl = this.baseUrl + "/" + parentId + "/" + this.nestedUrl;
        return this._deleteItem({ id: id }, baseUrl);
    };
    EndpointDeleterApiConsumer.prototype._deleteItem = function (_a, baseUrl) {
        var id = _a.id;
        if (baseUrl === void 0) { baseUrl = this.baseUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var delUrl;
            return __generator(this, function (_b) {
                delUrl = baseUrl + "/" + id + "?permanent=true";
                try {
                    return [2 /*return*/, this.instance.delete(delUrl)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    return EndpointDeleterApiConsumer;
}(BaseDeleterApiConsumer));
export default EndpointDeleterApiConsumer;
//# sourceMappingURL=endpoint-deleter-api-consumer.js.map