import { __assign, __awaiter, __extends, __generator } from "tslib";
import { EventEmitter } from 'ee-ts/lib/ee';
import Session from './session';
var ExternalClient = /** @class */ (function (_super) {
    __extends(ExternalClient, _super);
    function ExternalClient(config) {
        var _this = _super.call(this) || this;
        _this.config = config;
        _this.type = 'external';
        _this.schema = 'wtel://';
        return _this;
    }
    ExternalClient.prototype.callOption = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, req];
            });
        });
    };
    ExternalClient.prototype.register = function (sipConf) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    ExternalClient.prototype.unregister = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    ExternalClient.prototype.call = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!req.destination) {
                    return [2 /*return*/];
                }
                this.exec(req.destination);
                return [2 /*return*/];
            });
        });
    };
    ExternalClient.prototype.answer = function (id) {
        this.exec(id, 'answer');
    };
    ExternalClient.prototype.sipSessionByCallId = function (id) {
        return new Session(this, id);
    };
    ExternalClient.prototype.sipSessionBySipId = function (id) {
        return null;
    };
    ExternalClient.prototype.open = function (token) {
        this.exec(encodeURIComponent(JSON.stringify(__assign({ token: token }, this.config))), 'open');
    };
    ExternalClient.prototype.exec = function (args, action) {
        // TODO escape
        var url = "" + this.schema + args;
        if (action) {
            url += " " + action;
        }
        var link = document.createElement('a');
        link.download = 'File name';
        link.href = url;
        link.click();
        return;
    };
    return ExternalClient;
}(EventEmitter));
export { ExternalClient };
//# sourceMappingURL=index.js.map